config/routes.rb
Rails.application.routes.draw do

 root :to => 'pages#front'
  
 get 'ui(/:action)', controller: 'ui'
 
 get '/ruby-version' => 'application#ruby_version'

 resources :funds, except: [:destroy]
 resources :patrons, except: [:destroy]
 
 resources :recharges do
   collection do
     get 'search', to: 'recharges#search'
     get 'process_batch', to: 'recharges#process_batch'
     get 'create_output', to: 'recharges#create_output'
     get 'ftp_file', to: 'recharges#ftp_file'
   end 
 end

 resources :invoices do
   collection do
     get 'search', to: 'invoices#search'
     get 'process_batch', to: 'invoices#process_batch'
     get 'create_charge_output', to: 'invoices#create_charge_output'
     get 'create_person_output', to: 'invoices#create_person_output'
     get 'create_entity_output', to: 'invoices#create_entity_output'
     get 'ftp_file', to: 'invoices#ftp_file'
     get 'create_report', to: 'invoices#create_report'
     get 'merge_records', to: 'invoices#merge_records'
   end
 end

 get '/invoices/:id/create_bill', to: 'invoices#create_bill', as: :create_bill_invoice

 get "/signin", to: 'sessions#new', as: :signin
 get "/auth/shibboleth", as: :shibboleth
 get "/auth/developer", to: 'sessions#developer', as: :developer
 match "/auth/shibboleth/callback" => "sessions#shibboleth", as: :callback, via: [:get, :post]
 match "/signout" => "sessions#destroy", as: :signout, via: [:get, :post]
end

app/models/recharge.rb
# encoding: utf-8
#---
# @author hweng@ucsd.edu
#---

class Recharge < ActiveRecord::Base
  belongs_to :fund

  monetize :charge_cents, numericality: {
    greater_than_or_equal_to: 0,
    less_than_or_equal_to: 1_000_000
  }

  # validates :charge, presence: true, format: { :with => /\A\d+(?:\.\d{0,2})?\z/ }, numericality: {greater_than: 0, less_than: 1000000}

  validates :number_copies, presence: true
  validates :status, presence: true
  validates :fund_id, presence: true
  validates :document_num, presence: true

  delegate :org_code, to: :fund, prefix: :fund
  delegate :index_code, to: :fund, prefix: :fund
  delegate :fund_code, to: :fund, prefix: :fund
  delegate :program_code, to: :fund, prefix: :fund

  def self.search_by_index_code(search_term)
    return [] if search_term.blank?

    if !Fund.find_by(index_code: search_term).nil?
      fund_id = Fund.find_by(index_code: search_term)
      where('fund_id = ? ', fund_id).order('created_at DESC')
    else
      []
    end
  end

  # def self.search_by_ID(search_term)
  #   return [] if search_term.blank?

  #   where("fund_id = ? ", search_term).order("created_at DESC")
  # end

  def self.search_all_pending_status
    where(status: 'pending').order('created_at DESC')
  end

  def self.pending_status_count
    search_all_pending_status.count
  end

  def self.page_count; end

  ##
  # Handles mapping for RECHARGE output file
  #

  def self.total_charge
    result_arr = search_all_pending_status
    total_charge = 0

    result_arr.each_with_index do |v, _i|
      charge = v.charge
      total_charge += charge
    end
    total_charge
  end

  def self.process_output
    "#{header}#{detail}#{trailer}"
  end

  def self.header
    h_column1_19 = 'LIBRARY1' + '01' + document_column + '1'
    h_column20_54 = 'LIBRARY RECHARGES' + ' ' * 18
    transaction_date = convert_date_yyyymmdd(Time.zone.now)
    document_amount = convert_charge(total_charge * 2)
    h_column75_250 = 'N' + ' ' * 175

    "#{h_column1_19}#{h_column20_54}#{transaction_date}#{document_amount}#{h_column75_250}\n"
  end

  def self.detail
    result_arr = search_all_pending_status

    d_column1_19 = 'LIBRARY1' + '01' + document_column + '2'
    d_column24_27 = 'F510'
    d_column40_76 = 'LIBRARY-PHOTOCOPY SERVICE' + ' ' * 10 + 'D' + 'A'
    d_column89_94 = '636064'
    d_column101_112 = ' ' * 6 + ' ' * 6
    d_column123_209 = ' ' * 32 + '000000' + ' ' * 17 + '000000' + ' ' * 10 + '0000' + '0000' + ' ' * 8
    d_column220 = ' '
    detail_rows = ''

    result_arr.each_with_index do |recharge, index|
      sequence_num = convert_seq_num(index + 1)
      transaction_amount = convert_charge(recharge.charge)
      fund_code = recharge.fund_fund_code
      org_code = recharge.fund_org_code
      program_code = recharge.fund_program_code
      index_code = convert_index_code(recharge.fund_index_code)
      filler_var = convert_date_yyyymmdd(Time.zone.now) + ' ' * 2

      detail_rows += "#{d_column1_19}#{sequence_num}#{d_column24_27}#{transaction_amount}#{d_column40_76}#{fund_code}#{org_code}"
      detail_rows += "#{d_column89_94}#{program_code}#{d_column101_112}#{index_code}#{d_column123_209}#{filler_var}#{d_column220}\n"
    end
    detail_rows
  end

  def self.trailer
    f_column1_19 = 'LIBRARY1' + '01' + document_column + '2'
    f_sequence_num = convert_seq_num(pending_status_count + 1)
    f_column24_27 = 'F510'
    total_amount = convert_charge(total_charge)
    f_column40_76 = 'LIBRARY-PHOTOCOPY SERVICE' + ' ' * 10 + 'C' + 'A'
    f_column77_112 = ' ' * 12 + '693900' + ' ' * 18
    f_column113_122 = ' ' * 3 + 'LIBIL05'
    f_column123_154 = ' ' * 32
    f_column155_209 = '000000' + ' ' * 17 + '000000' + ' ' * 10 + '0000' + '0000' + ' ' * 8
    f_filler_var = convert_date_yyyymmdd(Time.zone.now) + ' ' * 2
    f_column220 = ' '

    "#{f_column1_19}#{f_sequence_num}#{f_column24_27}#{total_amount}#{f_column40_76}#{f_column77_112}#{f_column113_122}#{f_column123_154}#{f_column155_209}#{f_filler_var}#{f_column220}"
  end

  def self.document_column
    result_arr = search_all_pending_status
    document_num = ''
    result_arr.each do |recharge|
      document_num = recharge.document_num
    end

    'FRLBG' + convert_doc_num(document_num)
  end

  def self.create_file
    file_name = 'FISP.JVDATA.D' + convert_date_yymm(Time.zone.now) + '01.LIB'
    path = 'tmp/ftp/' + file_name
    content = process_output
    # puts Dir.pwd

    File.open(path, 'w') do |f|
      f.write(content)
    end

    file_name
  end

  def self.send_file
    file_name = create_file
    local_file_path = 'tmp/ftp/' + file_name
    remote_file_path = Rails.application.secrets.sftp_folder + '/' + file_name
    server_name = Rails.application.secrets.sftp_server_name
    user = Rails.application.secrets.sftp_user
    password = Rails.application.secrets.sftp_password

    Rails.logger.info('Creating SFTP connection')
    session = Net::SSH.start(server_name, user, password: password)
    sftp = Net::SFTP::Session.new(session).connect!
    Rails.logger.info('SFTP Connection created, uploading files.')
    sftp.upload!(local_file_path, remote_file_path)
    Rails.logger.info('File uploaded, Connection terminated.')
  end

  def self.convert_date_yymm(cdate)
    cdate.strftime('%y%m')
  end

  def self.convert_doc_num(doc_num)
    doc_num.to_s.rjust(3, '0') # 1 --> 001, 10 --> 010
  end

  def self.convert_seq_num(seq_num)
    seq_num.to_s.rjust(4, '0') # 1 --> 0001, 10 --> 0010
  end

  def self.convert_index_code(input)
    input.to_s.rjust(10, ' ') # 1 --> 0001, 10 --> 0010
  end

  def self.convert_charge(amount)
    s_amount = (100 * amount).to_f.round.to_s # 0.50 --> "50"
    '0' * (12 - s_amount.length) + s_amount
  end

  def self.convert_date_yyyymmdd(cdate)
    cdate.strftime('%Y%m%d')
  end
end

app/controllers/recharges_controller.rb
# encoding: utf-8
#---
# @author hweng@ucsd.edu
#---

require 'net/sftp'
require 'open-uri'

class RechargesController < ApplicationController
  before_action :require_user
  before_action :set_recharge, only: [:edit, :update]
  before_action :set_index_list, only: [:new, :create, :edit, :update]

  def index
    @total_count = Recharge.count
    @recharges = all_items(Recharge)
  end

  def new
    @recharge = Recharge.new
  end

  def create
    @recharge = Recharge.new(recharge_params)

    if @recharge.save
      redirect_to new_recharge_path, notice: 'A new recharge is created!'
    else
      render :new
    end
  end

  def edit
    @selected_index = @recharge.fund_id
    @selected_status = @recharge.status
  end

  def update
    if @recharge.update(recharge_params)
      flash[:notice] = 'Your recharge was updated'
      redirect_to new_recharge_path
    else
      render :edit
    end
  end

  def destroy
    recharge = Recharge.find(params[:id])
    recharge.destroy
    redirect_to recharges_path
  end

  def search
    result_arr = Recharge.search_by_index_code(params[:search_term])
    @search_result = result_arr.page(params[:page]) if result_arr.present?
    @search_count = result_arr.count
  end

  def process_batch
    @current_batch_count = Recharge.pending_status_count
    result_arr = Recharge.search_all_pending_status
    @current_batch_result = result_arr.page(params[:page]) if result_arr.present?
  end

  def create_output
    content = Recharge.process_output
    render plain: content
  end

  def ftp_file
    email_date = convert_date_mmddyy(Time.zone.now)
    Recharge.send_file
    AppMailer.send_recharge_email(current_user, email_date).deliver_now
    batch_update_status

    flash[:notice] = 'Your recharge file is uploaded to the campus server, and the email has been sent to ACT.'

    redirect_to recharges_path
  end

  private

  def batch_update_status
    batch_update_status_field(Recharge)
  end

  def recharge_params
    params.require(:recharge).permit(:number_copies, :charge, :status, :notes, :fund_id, :document_num)
  end

  def set_recharge
    @recharge = Recharge.find params[:id]
  end

  def set_index_list
    @index_list = Fund.order('index_code').map { |fund| [fund.index_code, fund.id] }
  end
end

app/views/recharges/edit.html.haml
%section.create.container
  .row
    .col-sm-8.col-sm-offset-1
      = bootstrap_form_for @recharge do |f|
        = render 'shared/content_title', title: "Edit a Recharge" 
        = render 'shared/error_messages', obj: @recharge
        %fieldset
          .required
            = f.text_field :document_num, label: "Document Number(1 ~ 999)"
          .required
            = f.select :fund_id, options_for_select(@index_list, selected: @selected_index), { label: "Index ID" }
          .required
            = f.text_field :number_copies, label: "Number of Copies"
          .required
            = f.text_field :charge, label: "Charge"
          .required
            = f.select :status, options_for_select(["active", "pending"], selected: @selected_status)
          = f.text_area :notes, label: "Notes", rows: 6
        %fieldset.actions.control-group.col-sm-offset-2
          .controls
            %input(type="submit" value="Save" class="btn btn-primary")
            %input(type="reset" value="Cancel" class="btn btn-default")
            = link_to "Go to index page", recharges_path, method: :get, class: 'btn btn-default'

app/views/recharges/index.html.haml
%section.my_queue.container
  .row
    .col-sm-10.col-sm-offset-1
      %article
        %header
          %h2
            There is total #{@total_count} recharges
        %table.table
          %thead
            %tr
              %th{ width: "15%" } Recharge ID
              %th{ width: "15%" } Document Number
              %th{ width: "15%" } Charge
              %th{ width: "15%" } Status
              %th{ width: "15%" } Number of Copies
              %th{ width: "15%" } Fund_ID
              %th{ width: "15%" } Creation Date
              %th{ width: "15%" } Link
          %tbody
            - if @recharges
              - @recharges.each do |recharge|
                %tr
                  %td
                    = recharge.id
                  %td
                    = recharge.document_num
                  %td
                    $
                    = recharge.charge
                  %td
                    = recharge.status
                  %td
                    = recharge.number_copies
                  %td
                    = recharge.fund_id
                  %td
                    = convert_date_mmddyy(recharge.created_at)
                  %td
                    = link_to edit_recharge_path(recharge.id) do
                      %i.glyphicon.glyphicon-pencil
          .pagination-wrapper
            = paginate @recharges if @recharges

app/views/recharges/new.html.haml
%section.create.container
  .row
    .col-sm-8.col-sm-offset-1
      = bootstrap_form_for @recharge do |f|
        = render 'shared/content_title', title: "Create a New Recharge" 
        = render 'shared/error_messages', obj: @recharge
        %fieldset
          .required
            = f.text_field :document_num, label: "Document Number(1 ~ 999)"
          .required
            = f.select :fund_id, @index_list, {include_blank: 'Choose Index ID'}, { label: "Index ID" }
          .required
            = f.text_field :number_copies, label: "Number of Copies"
          .required
            = f.text_field :charge, label: "Charge"
          .required
            = f.select :status, options_for_select(["active", "pending"], nil)
          = f.text_area :notes, label: "Notes", rows: 6
        %fieldset.actions.control-group.col-sm-offset-2
          .controls
            %input(type="submit" value="Save" class="btn btn-primary")
            %input(type="reset" value="Cancel" class="btn btn-default")
            = link_to "Go to index page", recharges_path, method: :get, class: 'btn btn-default'

            

app/views/recharges/process_batch.html.haml
%section.my_queue.container
  .row
    .col-sm-10.col-sm-offset-1
      %article
        %header
          %h2 
            There is #{@current_batch_count} recharge for current batch. 
            Please make sure all document numbers you input are the same in the batch.
        %table.table
          %thead
            %tr
              %th{ width: "15%" } Recharge ID
              %th{ width: "15%" } Document Number
              %th{ width: "15%" } Charge
              %th{ width: "15%" } Status
              %th{ width: "15%" } Number of Copies
              %th{ width: "15%" } Fund_ID
              %th{ width: "15%" } Creation Date
              %th{ width: "15%" } Link
          %tbody
            - if @current_batch_result
              - @current_batch_result.each do |recharge|
                %tr
                  %td 
                    = recharge.id
                  %td
                    = recharge.document_num
                  %td 
                    $
                    = recharge.charge
                  %td 
                    = recharge.status
                  %td 
                    = recharge.number_copies
                  %td 
                    = recharge.fund_id
                  %td 
                    = convert_date_mmddyy(recharge.created_at)
                  %td
                    = link_to edit_recharge_path(recharge.id) do
                      %i.glyphicon.glyphicon-pencil
          = paginate @current_batch_result if @current_batch_result
        %fieldset.actions.control-group.col-sm-offset-2
        .controls
          -#%a.btn.btn-primary(href="") FTP to ACT
          = link_to "Preview Output File", create_output_recharges_path, method: :get, class: 'btn btn-default'
          / Button trigger modal
          %button.btn.btn-primary{"data-target" => "#ftp-notes", "data-toggle" => "modal"}
            FTP to ACT
          = render 'shared/modal', target_url: ftp_file_recharges_path, msg_body: "Are you sure you want to upload the current batch to ACT server?"
          

app/views/recharges/search.html.haml
%section.my_queue.container
  .row
    .col-sm-10.col-sm-offset-1
      %article
        %header
          %h2 
            #{@search_count} recharges found from database.
        = form_tag search_recharges_path, method: "GET", id: "myForm" do
          .input-group.front-input
            %input.form-control.search-input(name="search_term" type="text" placeholder="Search by Index Code")
              .input-group-btn
                %button.btn.btn-default(type="submit")
                  %span.glyphicon.glyphicon-search.right2{"aria-hidden" => "true"}
        %br
        - if @search_count > 0
          %table.table
            %thead
              %tr
                %th{ width: "15%" } Recharge ID
                %th{ width: "15%" } Document Number
                %th{ width: "15%" } Charge
                %th{ width: "15%" } Status
                %th{ width: "15%" } Number of Copies
                %th{ width: "15%" } Fund_ID
                %th{ width: "15%" } Creation Date
                %th{ width: "15%" } Link
            %tbody
              - if @search_result
                - @search_result.each do |recharge|
                  %tr
                    %td
                      = recharge.id
                    %td
                      = recharge.document_num
                    %td
                      $ 
                      = recharge.charge
                    %td 
                      = recharge.status
                    %td 
                      = recharge.number_copies
                    %td 
                      = recharge.fund_id
                    %td 
                      = convert_date_mmddyy(recharge.created_at)
                    - if recharge.status != "submitted"
                      %td
                        = link_to edit_recharge_path(recharge.id) do
                          %i.glyphicon.glyphicon-pencil
            = paginate @search_result if @search_result
        